from flask import current_app, jsonify, request
from apps.models import *
from apps.models import ProjectManagement
from apps.utils.response_code import RET
from apps.big_data import api_bigdata


# 获取项目列表
@api_bigdata.route("/GetProject", methods=["POST"])
def get_project():
    req_dic = request.get_json()

    # # token = request.headers['token']
    #
    # project_stalker = req_dic['project_stalker']
    #
    # project_name = req_dic['project_name']
    # district = req_dic['district']
    # development_area = req_dic['development_area']
    # investor_name = req_dic['investor_name']
    # investor_district = req_dic['investor_district']
    # industry = req_dic['industry']
    # industry2 = ''
    # if '/' in industry:
    #     industry1 = industry.split('/')[0]
    #     industry2 = industry.split('/')[1]
    # else:
    #     industry1 = industry
    # investment_volume = req_dic['investment_volume']
    # project_progress = req_dic['project_progress']
    # project_year = req_dic['project_year']
    page = req_dic['page']
    per_page = req_dic['per_page']
    # flag = req_dic['flag']

    # try:
    #     user_obj = verify_token(token)
    #     user_district = get_district_name(token)
    # except Exception as e:
    #     current_app.logger.error(e)
    #     return jsonify(code=RET.SESSIONERR, msg="进行操作时用户信息校验失败，请重新登陆后尝试！")

    try:
        # project_obj = ProjectManagement.query.filter(
        #     ProjectManagement.project_name.like('%{}%'.format(project_name)) if project_name else text(''),
        #     ProjectManagement.project_stalker == project_stalker if project_stalker else text(''),
        #     ProjectManagement.district == district if district else text(''),
        #     ProjectManagement.development_area == development_area if development_area else text(''),
        #     ProjectManagement.investment_volume > investment_volume[0] if investment_volume else text(''),
        #     ProjectManagement.investment_volume <= investment_volume[1] if investment_volume else text(''),
        #     ProjectManagement.investor_district.like('%{}%'.format(investor_district)) if investor_district else text(
        #         ''),
        #     ProjectManagement.industry.like('%{}%'.format(industry1)) if industry1 else text(''),
        #     ProjectManagement.industry2.like('%{}%'.format(industry2)) if industry2 else text(''),
        #     ProjectManagement.investor_name.like('%{}%'.format(investor_name)) if investor_name else text(''),
        #     ProjectManagement.project_progress == project_progress if project_progress else text(''),
        #     ProjectManagement.project_year == project_year if project_year else text(''),
        #     ProjectManagement.is_delete == 0
        # )

        project_obj = ProjectManagement.query.filter(
            # ProjectManagement.district == user_district if user_district != '晋城市' else text(''),
            # ProjectManagement.sign_time.notin_(['Null', '']) if flag == 2 else text(''),
            # ProjectManagement.project_name.like('%{}%'.format(project_name)) if project_name else text(''),
            # ProjectManagement.project_stalker == project_stalker if project_stalker else text(''),
            # ProjectManagement.project_stalker != '' if flag == 2 else text(''),
            # ProjectManagement.district == district if district else text(''),
            # ProjectManagement.development_area == development_area if development_area else text(''),
            # ProjectManagement.investment_volume > investment_volume[0] if investment_volume else text(''),
            # ProjectManagement.investment_volume <= investment_volume[1] if investment_volume else text(''),
            # ProjectManagement.investor_district.like('%{}%'.format(investor_district)) if investor_district else text(''),
            # ProjectManagement.industry.like('%{}%'.format(industry1)) if industry1 else text(''),
            # ProjectManagement.industry2.like('%{}%'.format(industry2)) if industry2 else text(''),
            # ProjectManagement.investor_name.like('%{}%'.format(investor_name)) if investor_name else text(''),
            # ProjectManagement.project_progress == project_progress if project_progress else text(''),
            # ProjectManagement.project_year == project_year if project_year else text(''),
            ProjectManagement.is_delete == 0
        )

        if not project_obj.all():
            return jsonify(code=RET.NODATA, msg='没有符合条件的数据！')
        project_size = project_obj.count()

        project_obj_list = project_obj.order_by(ProjectManagement.upload_time.desc()).paginate(page, per_page).items
        if project_obj_list:
            data = [{
                "id": project_obj.id,
                "project_stalker": project_obj.project_stalker,
                "project_name": project_obj.project_name,
                "district": project_obj.district,
                "development_area": project_obj.development_area,
                "attract_name": project_obj.attract_name,
                "investor_name": project_obj.investor_name,
                "investor_district": project_obj.investor_district,
                "industry": project_obj.industry,
                "investment_volume": project_obj.investment_volume,
                "construction_content": project_obj.construction_content,
                "project_address": project_obj.project_address,
                "project_progress": project_obj.project_progress,
                "project_problem": project_obj.project_problem,
                "project_year": project_obj.project_year
            } for project_obj in project_obj_list]
            return jsonify(code=RET.OK, data={"data": data, "size": project_size, "msg": "数据获取成功！"})

    except Exception as e:
        current_app.logger.error(e)
        return jsonify(code=RET.DBERR, msg="查询数据库错误！")
